atom
	var
		AI_active = 0	//Keep track of whether this atom's AI proc is running.
		client/client	//This allows us to check for a client for any atom. Null by default.
	New()
		..()
		determinePage()
		AI()
	Crossed(atom/movable/O)
		..()
		if(istype(O, /atom/movable/camera)) return //Camera objects cannot trigger an atom to activate.
		var/triggered = 0
		for(var/i in _page01__triggers)
			if(istext(i)) switch(lowertext(i))
				if("cross","bump","touch") triggered = 1
		if(triggered)
			activate(O.client)
	proc
		AI() //By default, this proc does nothing.
		Bumped(atom/movable/O)
			..()
			var/triggered = 0
			for(var/i in _page01__triggers)
				if(istext(i)) switch(lowertext(i))
					if("cross","bump","touch") triggered = 1
			if(triggered)
				activate(O.client)
		iconWidth()
			if(icon)
				var/icon/I = new(icon)
				return I.Width()
			else return 0
	movable
		step_size = 3
		var
			atom/movable/hud/inventory_slot/inventory_slot = 0	//Keep track of the inventory slot that is holding this movable atom (if the atom is being held).
		Bump(atom/movable/O)
			..()
			O.Bumped(src)
		proc
			find_inventory_slot(atom/A)
				var/slot_found = 0
				if(A.client)
					A.client.HUD_refresh()
					var/list/slots = A.client.HUD_inventory.inventory_slots
					for(var/atom/movable/hud/inventory_slot/S in slots)
						if(S.item_count <= 0 && slot_found <= 0)
							inventory_slot = S
							slot_found = 1
				return slot_found
		verb
			get(var/mob/M = usr)
				set hidden = 1
				set src in orange(1)
				if(M)
					var/triggered = 0
					for(var/i in _page01__triggers)
						if(istext(i)) switch(lowertext(i))
							if("get verb","get","verb: get","verb get") triggered = 1
					if(triggered)
						activate(M.client)
					else
						M.inventory_add(src) //If not triggered, then just add to the inventory.
			drop(var/mob/M = usr)
				set hidden = 1
				set src in usr
				if(M)
					var
						center_x = M.step_x + bound_x + round(bound_width/2)
						center_y = M.step_y + bound_y + round(bound_height/2)
						dx = rand(-M.bound_width, M.bound_width)
						dy = rand(-M.bound_height, M.bound_height)
					if(!Move(M.loc, M.dir, center_x + dx, center_y + dy))
						loc = M.loc
						dir = M.dir
						step_x = center_x + dx
						step_y = center_y + dy