client
	perspective = EDGE_PERSPECTIVE
	var
		state = MOVE	//Default state when first logging in.
		previous_state	//Keep track of previous state when changing states.
		step_size = 4	//Default step size for new clients' mobs.
		obj/command/menu_option/menuOption	//Keep track of which menu option over which the player is currently hovering.
		music			//Keep track of the music currently being played, for this client. Controlled by atom "music" commands.
	proc
		ViewWidth() //returns this client's view width, in pixels.
			if(isnum(view)) return (view * 2 + 1) * world.icon_size
			else return text2num(copytext(view, 1, findtext(view, "x"))) * world.icon_size
		ViewHeight() //returns this client's view height, in pixels.
			if(isnum(view)) return (view * 2 + 1) * world.icon_size
			else return text2num(copytext(view, findtext(view, "x")+1)) * world.icon_size
		state(var/next_state) //Adopt a new client state
			if(next_state)
				if(next_state != state) previous_state = state //Keep track of most recent state that isn't the current state.
				state = next_state //Assign the new state.
				east = 0	//If these keys are currently being pressed, forget they are being pressed when entering the new state.
				south = 0
				west = 0
				north = 0
				if(state != HUD_WINDOW)
					mob.jump = 0 //If client's mob is in the middle of a jump, then end the jump.
					mob.jump_speed = 0
				if(state == MENU) findMenuOption()
		previous_state() //Adopt the previous state, before the current state.
			state(previous_state)
		findMenuOption(searchDir = null) //Locates the top-left menu option in the current menu area.
			var
				x1 = mob.x
				y1 = mob.y
				loc1 = mob.loc
				obj/command/menu_option/nextMenuOption
			for(var/obj/command/menu_option/O in world)
				if(O.z == mob.z && O != menuOption)
					if(searchDir) //If we are looking in a direction, we want to find the nearest menu option in that direction.
						switch(searchDir)
							if(EAST)
								if(get_dir(loc1,O) == EAST)
									if(O.x > x1 && get_dist(loc1,O) <= get_dist(loc1,nextMenuOption)) nextMenuOption = O
							if(WEST)
								if(get_dir(loc1,O) == WEST)
									if(O.x < x1 && get_dist(loc1,O) <= get_dist(loc1,nextMenuOption)) nextMenuOption = O
							if(NORTH)
								if(get_dir(loc1,O) == NORTH)
									if(O.y > y1 && get_dist(loc1,O) <= get_dist(loc1,nextMenuOption)) nextMenuOption = O
							if(SOUTH)
								if(get_dir(loc1,O) == SOUTH)
									if(O.y < y1 && get_dist(loc1,O) <= get_dist(loc1,nextMenuOption)) nextMenuOption = O
					else
						if(nextMenuOption == null) nextMenuOption = O //Find a menu option, if any is nearby.
						else //By default, we want to located the menu option in the upper left.
							if(O.x < nextMenuOption.x) nextMenuOption = O
							if(O.y > nextMenuOption.y) nextMenuOption = O
			if(nextMenuOption)
				if(searchDir) mob << sound('select11.wav', volume=50)
				menuOption = nextMenuOption
				mob.Move(menuOption.loc)
			else
				mob << sound('select7.wav', volume=40)
