/*
	Woo Engine
	By Tyruswoo
	www.tyruswoo.com
*/

//Client states
#define MOVE 		1	//Gap-nudge movement.
#define JUMP		2	//Platformer movement.
#define MENU		3	//Selecting from a menu.
#define CHAT		4	//Typing into chat.
#define HUD_WINDOW	5	//HUD window open

proc/soundJump()
	var sound = pick('jump1.wav','jump2.wav','jump3.wav','jump4.wav','jump5.wav','jump6.wav','jump7.wav')
	return sound

world
	fps = 60
	icon_size = 32
	view = "23x13"
	mob = /mob/player
	map_format = SIDE_MAP
	New()
		..()
		var/datum/autoDatum/D = new()
		D.tag = "autoDatum"
		AI()
	proc
		AI()
			var/datum/autoDatum/D = locate("autoDatum")
			for(var/atom/A in D.autoAtomList)
				for(var/mob/M in range(1000, A))
					if(M.client) //All client-associated mobs on this z level will activate auto commands.
						A.activate(M.client)
			spawn(1/fps) .()

datum
	autoDatum
		var/list/autoAtomList = list()
		New()
			..()
			for(var/atom/A in world)
				for(var/i in A._page01__triggers)
					if(istext(i))
						switch(lowertext(i))
							if("auto") autoAtomList.Add(A) //Find all atoms that are automatically triggered.
							if("once") A.activate() //Find all atoms that trigger only once at runtime, and activate them.